package com.atsuishio.superbwarfare.client.model.entity;

import com.atsuishio.superbwarfare.ModUtils;
import com.atsuishio.superbwarfare.entity.projectile.GunGrenadeEntity;
import net.minecraft.resources.ResourceLocation;
import software.bernie.geckolib.core.animatable.model.CoreGeoBone;
import software.bernie.geckolib.core.animation.AnimationState;
import software.bernie.geckolib.model.GeoModel;

public class GunGrenadeModel extends GeoModel<GunGrenadeEntity> {

    @Override
    public ResourceLocation getAnimationResource(GunGrenadeEntity entity) {
        return ModUtils.loc("animations/cannon_shell.animation.json");
    }

    @Override
    public ResourceLocation getModelResource(GunGrenadeEntity entity) {
        return ModUtils.loc("geo/cannon_shell.geo.json");
    }

    @Override
    public ResourceLocation getTextureResource(GunGrenadeEntity entity) {
        return ModUtils.loc("textures/entity/cannon_shell.png");
    }

    @Override
    public void setCustomAnimations(GunGrenadeEntity animatable, long instanceId, AnimationState animationState) {
        CoreGeoBone bone = getAnimationProcessor().getBone("bone");
        bone.setScaleX(0.2f);
        bone.setScaleY(0.2f);
        bone.setScaleZ(0.2f);
    }
}
